// COnstructorul de Copiere (Copy Constructor)
#include <iostream>
#include <string>

class Book {
public:
    Book() : title {""}, price {0}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Book(std::string title, int price) :
        title {title}, price {price}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    // Constructor de Copiere
    Book(const Book& b) :
        title {b.title + " Creanga"},
        price {b.price + 10}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    void PrintBook() const
    {
        std::cout << title << ' ' << price << '\n';
    }

    ~Book()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }


private:
    std::string title;
    int price;
};

int main()
{
    Book b1 {"ION", 30};

    Book b2 = b1; // Deep Copy (Copie Profunda)

    b2.PrintBook();
}
