// Constructorul de Copiere (Copy Constructor)
#include <iostream>
#include <string>

class Book {
public:
    Book() : title {""}, price {0}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Book(std::string title, int price) :
        title {title}, price {price}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    // Constructor de Copiere
    Book(const Book& b) :
        title {b.title},
        price {b.price}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    void PrintBook() const
    {
        std::cout << title << ' ' << price << '\n';
    }

    ~Book()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    void SetTitle(std::string t)
    {
        title = t;
    }
private:
    std::string title;
    int price;
};

// La Apelul "Prin Valoare" parametrul (b)
// se construieste prin copiere din argument (b1)
void F(Book b)
{
}

void G(const Book& b)
{
    b.SetTitle("Rascoala");
}

int main()
{
    Book b1 {"ION", 30};

 //   F(b1);
    G(b1);
    b1.PrintBook();
}
